'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = normalize;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function readEntity(item) {
  var entity = {};
  entity['id'] = item.id;
  for (var key in item.attributes) {
    entity[key] = item.attributes[key];
  }

  if (item.relationships) {
    for (var _key in item.relationships) {
      var rel = item.relationships[_key];
      if (Array.isArray(rel.data)) {
        entity[_key] = rel.data.map(function (x) {
          return x.id;
        });
      } else {
        entity[_key] = rel.data ? rel.data.id : rel.data;
      }
    }
  }

  return entity;
}

function readEntities(data) {
  var included = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

  var entities = {};
  var result = [];
  if (Array.isArray(data)) {
    data.forEach(function (item) {
      var entity = readEntity(item);
      entities[item.type] = entities[item.type] || {};
      entities[item.type][item.id] = entity;
      if (!included) {
        result.push(item.id);
      }
    });
  } else {
    entities[data.type] = entities[data.type] || {};
    entities[data.type][data.id] = readEntity(data);
    if (!included) {
      result.push(data.id);
    }
  }

  return { entities: entities, result: result };
}

function normalize(payload) {
  var data = readEntities(payload.data);
  var included = payload.included ? readEntities(payload.included, true) : { result: [] };

  var entities = _extends({}, data['entities'], included['entities']);
  var result = [].concat(_toConsumableArray(data['result']), _toConsumableArray(included['result']));
  return { entities: entities, result: result };
}